<!DOCTYPE html>
<html>
  <head>
    <title>Redux basic example</title>
    <!-- STEP 1.1 -->
    <script src="https://npmcdn.com/redux@latest/dist/redux.min.js"></script>
    <!-- END 1.1 -->
  </head>
  <body>
    <div>
      <p>
        Clicked: <span id="value">0</span> times
        <button id="decrement">Decrease</button>
        <button id="incrementAsync">Increment async</button>
      </p>
      <p>
        <input id="a" value="0" style="width: 50px;">
        +
        <input id="b" value="0" style="width: 50px;">
        =
        <span id="value2">0</span>
        <button id="sum">Sum</button>
      </p>
    </div>
    <script>
      // STEP 1.2
      var store = Redux.createStore(counter);
      // END 1.2
      function render() {
        var state = store.getState();
        document.getElementById('value').innerHTML = state.count;
        document.getElementById('value2').innerHTML = state.sum;
      }
      // Invokes render everytime the state gets updated
      store.subscribe(render);
      // STEP 2.2 Reducer
      function counter(currentState, action) {
        var DEFAULT_STATE = { count: 0, sum: 0 };
        var nextState = Object.assign({}, currentState);

        if (currentState === undefined) {
          nextState = DEFAULT_STATE;
          return nextState;
        }

        switch(action.type) {
          case 'DECREMENT':
            nextState.count = currentState.count - 1;
            return nextState;
          case 'INCREMENT':
            nextState.count = currentState.count + 1;
            return nextState;
          case 'SUM':
            nextState.sum = action.a + action.b;
            return nextState;
          default:
            return nextState;
        }
      };
      // END 2.2

      document.getElementById('decrement')
        .addEventListener('click', function () {
            var action = { type: 'DECREMENT' };
            // store.dispatch sends the action to the reducer (counter)
            store.dispatch(action);
        })
      document.getElementById('incrementAsync')
        .addEventListener('click', function () {
          setTimeout(
            function increment () {
              var action = { type: 'INCREMENT' };
              store.dispatch(action);
            }
          , 1000); // execute increment () method after 1000 millisecond or 1 second
        })
      // Excercise 2
      document.getElementById('sum')
        .addEventListener('click', function() {
          var a = document.getElementById('a').value;
          var b = document.getElementById('b').value;
          var action = { type: 'SUM', a: parseInt(a), b: parseInt(b) };
          store.dispatch(action);
        });
    </script>
  </body>
</html>
